
[org 0x7c00]

[bits 16]

sti



cli

jmp l

l:


lgdt [gdtinfo]


mov eax,cr0
or eax,1
mov cr0,eax

;After it set registers and do a far jump to kernel. If data selector is 10h, code selector is 8 and kernel offset is 10000h do:


mov ax,0x10
mov ds,ax

mov es,ax
mov fs,ax
mov gs,ax
mov ss,ax




jmp dword 0x8:0x100000

hlt


gdtinfo:
   dw gdt_end - gdt - 1   ;last byte in table
   dd gdt                 ;start of table
 
gdt         dd 0,0        ; entry 0 is always unused
; gdt code:	            ; code descriptor
	dw 0FFFFh           ; limit low
	dw 0                ; base low
	db 0                ; base middle
	db 10011010b        ; access
	db 11001111b        ; granularity
	db 0                ; base high

; gdt data:	            ; data descriptor
	dw 0FFFFh           ; limit low (Same as code)
	dw 0                ; base low
	db 0                ; base middle
	db 10010010b        ; access
	db 11001111b        ; granularity
	db 0                ; base high
gdt_end:


